/*****************************************************
This program was produced by the
CodeWizardAVR V2.04.4a Advanced
Automatic Program Generator
 Copyright 1998-2009 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : DigitMag1
Version : 1.05
Date    : 29.01.2010
Author  : RA9YTJ
Company : home
Comments: 


Chip type               : ATmega32
Program type            : Application
AVR Core Clock frequency: 16,000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 512
*****************************************************/

#include <mega32.h>
#include <sleep.h>
#include <delay.h>
#include <spi.h>

#define ADC_VREF_TYPE 0x20


char i,mode,flag,rec,m1,m2,m3,m4,m5,m6;
unsigned int index;
unsigned long carentsector,MaxSector,MaxSector1,sec,fullsectors,sizef;
unsigned long StartSec[6];
char bufa[512];
char bufb[512];

// ADC interrupt service routine
interrupt [ADC_INT] void adc_isr(void)
{
unsigned char adc_data;
adc_data=ADCH;
{
if (PINC.6)
 rec=0;   
else
 if (rec<250) rec++;
  
if (PINC.0)
 m1=0;
else
 if (m1<250) m1++;

if (PINC.1)
 m2=0;
else
 if (m2<250) m2++;

if (PINC.2)
 m3=0;
else
 if (m3<250) m3++;

if (PINC.3)
 m4=0;
else
 if (m4<250) m4++;

if (PINC.4)
 m5=0;
else
 if (m5<250) m5++;

if (PINC.5)
 m6=0;
else
 if (m6<250) m6++;

}
 switch (mode)
 {
  case 1:
  {
  if (flag)
  {
   OCR2=bufa[index];
   index++; 
  }
  else
  {
  OCR2=bufb[index];
  index++;
  }
}
  break;
  case 2:
  {
  if (flag)
  {
   bufa[index]=adc_data;
   index++;  
  }
  else
  {
   bufb[index]=adc_data;
   index++;   
  }
 }
 break;
 case 3: OCR2=adc_data; 
 }
if (index==512)
{
  index=0;
  flag=~flag;
 }
}


char card_Command(char cmdF, unsigned long Adr, char cmdH )
{ 
 spi(0xFF);
 spi(cmdF);
 spi((char)(Adr >> 24));
 spi((char)(Adr  >> 16));
 spi((char)(Adr >> 8));
 spi((char)Adr);
 spi(cmdH);
 spi(0xFF);
 return spi(0xFF);
}

char card_Init()
{ 
 char ii;
 PORTB.4=1;
 for(ii=0; ii < 10; ii++) spi(0xFF);
 PORTB.4=0;
 if (card_Command(0x40,0,0x95) != 1) return 1;
 while (card_Command(0x41,0,0xFF) !=0);
 return 0;        
}

char card_ReadSector(unsigned long Sector, char *AdrBuf)
{
 int ii;
 PORTB.4=1;
 for(ii=0; ii < 10; ii++) spi(0xFF);
 PORTB.4=0;                  
 if (card_Command(0x51,(Sector<<9),0xFF) != 0) return 1; 
 while(spi(0xFF) != 0xFE);
 for(ii=0; ii < 512; ii++) *AdrBuf++=spi(0xFF);
 spi(0xFF);
 spi(0xFF);
 return 0;
}             

char card_WriteSector(unsigned long Sector, char *AdrBuf)
{
 int ii;
 PORTB.4=1;
 for(ii=0; ii < 10; ii++) spi(0xFF);
 PORTB.4=0;  
 if (card_Command(0x58,(Sector<<9),0xFF) !=0) return 1;
 spi(0xFF);
 spi(0xFF);                 
 spi(0xFE);
 for (ii=0;ii<512; ii++) spi(*AdrBuf++);    
 spi(0xFF);                 
 spi(0xFF);               
 if ((spi(0xFF)& 0x1F) != 0x05) return 2;
 while(spi(0xFF) != 0xFF);
 return 0;
}

char GetB_RECORD()
{
 if (rec==250)
  { 
   rec=255;
   return 1;
   }
 return 0;   
}

char GetB_M()
{
if (m1==250)
  { 
   m1=255;
   return 1;
   }
if (m2==250)
  { 
   m2=255;
   return 2;
   }
if (m3==250)
  { 
   m3=255;
   return 3;
   }
if (m4==250)
  { 
   m4=255;
   return 4;
   }
if (m5==250)
  { 
   m5=255;
   return 5;
   }
if (m6==250)
  { 
   m6=255;
   return 6;
   }              
 return 0;
 }   

void Set_M(char mm,char dd)
{
 switch (mm)
 {
  case 1: PORTD.0=dd;
  break;
  case 2: PORTD.1=dd;
  break;
  case 3: PORTD.2=dd;
  break;
  case 4: PORTD.3=dd;
  break;
  case 5: PORTD.4=dd;
  break;
  case 6: PORTD.5=dd;
  break;
 }           
}

void main(void)
{
PORTA=0xFE;
DDRA=0x00;
PORTB=0x00;
DDRB=0xB3;
PORTC=0xFF;
DDRC=0x00;
PORTD=0x00;
DDRD=0xFF;
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
ASSR=0x00;
TCCR2=0x69;
TCNT2=0x00;
OCR2=0x00;
MCUCR=0x00;
MCUCSR=0x00;
TIMSK=0x00;
ACSR=0x80;
SFIOR=0x00;
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0x8D;
SPCR=0x50;
SPSR=0x00;

i=0;
mode=0;
flag=0;
index=0;
rec=0;
m1=0;
m2=0;
m3=0;
m4=0;
m5=0;
m6=0;

#asm("sei")
ADCSRA=0xEE;
if (card_Init()) {PORTD=0xFF; powerdown();}
sizef=0xFE-(PINA & 0xFE);
if ( sizef==0) sizef=1;
fullsectors=0x8000*sizef;
MaxSector = ((fullsectors*0.9)/6)-10;
StartSec[0]=0;
StartSec[1]=MaxSector+5;
StartSec[2]=(MaxSector+5)*2;
StartSec[3]=(MaxSector+5)*3;
StartSec[4]=(MaxSector+5)*4;
StartSec[5]=(MaxSector+5)*5;

while (1)
 {
      if(!PINC.7) mode=3;
      else  mode=0;
      if (GetB_RECORD())
      {
       PORTD.6=1;
       while (i==0)
       {
       if (GetB_RECORD())  { PORTD.6=0; break;}
       else
       {
       i=GetB_M();
       if (i)
       {
        Set_M(i,1);
        carentsector=StartSec[i-1];
        index=3;
        flag=0;
        mode=2;
        PORTB.0=1;
        sec=0;
        while ((GetB_M()!=i)&(sec<MaxSector))
        {
         while (flag==0);
         if (card_WriteSector(carentsector+sec,bufb)){PORTD=0xFF; powerdown();}
         sec++;
         while (flag==0xFF);
         if (card_WriteSector(carentsector+sec,bufa)){PORTD=0xFF; powerdown();}
         sec++;         
        }        
       }
       }
       }
       mode=0;

       if (card_ReadSector(StartSec[i-1],bufa)){PORTD=0xFF; powerdown();}       
       bufa[0]=sec;
       bufa[1]=sec>>8;
       bufa[2]=sec>>16;
       bufa[3]=sec>>24;              
       if (card_WriteSector(StartSec[i-1],bufa)){PORTD=0xFF; powerdown();}       
       PORTD=0;
       PORTB.0=0;       
      }
      else
      {
       PORTD.6=0;
       i=GetB_M();
       if (i)
       {
        Set_M(i,1);
        carentsector=StartSec[i-1];
        if (card_ReadSector(StartSec[i-1],bufa)){PORTD=0xFF; powerdown();}
        sec=bufa[0];   
        MaxSector1=sec;
        sec=bufa[1];   
        MaxSector1=MaxSector1+(sec<<8);
        sec=bufa[2];   
        MaxSector1=MaxSector1+(sec<<16);
        sec=bufa[3];   
        MaxSector1=MaxSector1+(sec<<24);                                     
        index=3;
        flag=0;
        mode=1;
        PORTB.1=1;
        sec=0;
        while ((GetB_M()!=i)&(sec<MaxSector1))
        {
         while (flag==0);
         if (card_ReadSector(carentsector+sec,bufb)){PORTD=0xFF; powerdown();}
         sec++;
         while (flag==0xFF);
         if (card_ReadSector(carentsector+sec,bufa)){PORTD=0xFF; powerdown();}
         sec++;         
        }        
       mode=0;
       PORTB.1=0;
       PORTD=0;             
       }
      }     
      }
}
